View Issue Details

IDProjectCategoryView StatusLast Update
14387Bug reportsOtherpublic2019-05-15 12:56
ReporterDenisChenu Assigned Todominikvitt 
PrioritynoneSeverityminor 
Status closedResolutionfixed 
Product Version4.0.0dev 
Summary14387: Array to string conversion on upgrade
Description

PHP notice : Array to string conversion when update from 403

Steps To Reproduce

Unsure ;) can send my db if needed

TagsNo tags attached.
Complete LimeSurvey version number (& build)4.0.0 github
I will donate to the project if issue is resolvedNo
Browsernot relevant
Database & DB-Versionmariadb
Server OS (if known)fedora/linux
Webserver software & version (if known)nginx
PHP Versionphp7.2

Activities

DenisChenu

DenisChenu

2019-01-01 17:08

developer  

PHP notice.html (16,815 bytes)   
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"><head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>PHP notice</title>

<style type="text/css">
/*<![CDATA[*/
html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,font,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,ol,ul,li,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td{border:0;outline:0;font-size:100%;vertical-align:baseline;background:transparent;margin:0;padding:0;}
body{line-height:1;}
ol,ul{list-style:none;}
blockquote,q{quotes:none;}
blockquote:before,blockquote:after,q:before,q:after{content:none;}
:focus{outline:0;}
ins{text-decoration:none;}
del{text-decoration:line-through;}
table{border-collapse:collapse;border-spacing:0;}

body {
	font: normal 9pt "Verdana";
	color: #000;
	background: #fff;
}

h1 {
	font: normal 18pt "Verdana";
	color: #f00;
	margin-bottom: .5em;
}

h2 {
	font: normal 14pt "Verdana";
	color: #800000;
	margin-bottom: .5em;
}

h3 {
	font: bold 11pt "Verdana";
}

pre {
	font: normal 11pt Menlo, Consolas, "Lucida Console", Monospace;
}

pre span.error {
	display: block;
	background: #fce3e3;
}

pre span.ln {
	color: #999;
	padding-right: 0.5em;
	border-right: 1px solid #ccc;
}

pre span.error-ln {
	font-weight: bold;
}

.container {
	margin: 1em 4em;
}

.version {
	color: gray;
	font-size: 8pt;
	border-top: 1px solid #aaa;
	padding-top: 1em;
	margin-bottom: 1em;
}

.message {
	color: #000;
	padding: 1em;
	font-size: 11pt;
	background: #f3f3f3;
	-webkit-border-radius: 10px;
	-moz-border-radius: 10px;
	border-radius: 10px;
	margin-bottom: 1em;
	line-height: 160%;
}

.source {
	margin-bottom: 1em;
}

.code pre {
	background-color: #ffe;
	margin: 0.5em 0;
	padding: 0.5em;
	line-height: 125%;
	border: 1px solid #eee;
}

.source .file {
	margin-bottom: 1em;
	font-weight: bold;
}

.traces {
	margin: 2em 0;
}

.trace {
	margin: 0.5em 0;
	padding: 0.5em;
}

.trace.app {
	border: 1px dashed #c00;
}

.trace .number {
	text-align: right;
	width: 2em;
	padding: 0.5em;
}

.trace .content {
	padding: 0.5em;
}

.trace .plus,
.trace .minus {
	display:inline;
	vertical-align:middle;
	text-align:center;
	border:1px solid #000;
	color:#000;
	font-size:10px;
	line-height:10px;
	margin:0;
	padding:0 1px;
	width:10px;
	height:10px;
}

.trace.collapsed .minus,
.trace.expanded .plus,
.trace.collapsed pre {
	display: none;
}

.trace-file {
	cursor: pointer;
	padding: 0.2em;
}

.trace-file:hover {
	background: #f0ffff;
}
/*]]>*/
</style>
</head>

<body>
<div class="container">
	<h1>PHP notice</h1>

	<p class="message">
		Array to string conversion	</p>

	<div class="source">
		<p class="file">/mnt/data/shnoulle/nginx/www/develop/framework/db/CDbCommand.php(337)</p>
		<div class="code"><pre><span class="ln">325</span>         else
<span class="ln">326</span>             $par='';
<span class="ln">327</span>         Yii::trace('Executing SQL: '.$this-&gt;getText().$par,'system.db.CDbCommand');
<span class="ln">328</span>         try
<span class="ln">329</span>         {
<span class="ln">330</span>             if($this-&gt;_connection-&gt;enableProfiling)
<span class="ln">331</span>                 Yii::beginProfile('system.db.CDbCommand.execute('.$this-&gt;getText().$par.')','system.db.CDbCommand.execute');
<span class="ln">332</span> 
<span class="ln">333</span>             $this-&gt;prepare();
<span class="ln">334</span>             if($params===array())
<span class="ln">335</span>                 $this-&gt;_statement-&gt;execute();
<span class="ln">336</span>             else
<span class="error"><span class="ln error-ln">337</span>                 $this-&gt;_statement-&gt;execute($params);
</span><span class="ln">338</span>             $n=$this-&gt;_statement-&gt;rowCount();
<span class="ln">339</span> 
<span class="ln">340</span>             if($this-&gt;_connection-&gt;enableProfiling)
<span class="ln">341</span>                 Yii::endProfile('system.db.CDbCommand.execute('.$this-&gt;getText().$par.')','system.db.CDbCommand.execute');
<span class="ln">342</span> 
<span class="ln">343</span>             return $n;
<span class="ln">344</span>         }
<span class="ln">345</span>         catch(Exception $e)
<span class="ln">346</span>         {
<span class="ln">347</span>             if($this-&gt;_connection-&gt;enableProfiling)
<span class="ln">348</span>                 Yii::endProfile('system.db.CDbCommand.execute('.$this-&gt;getText().$par.')','system.db.CDbCommand.execute');
<span class="ln">349</span> 
</pre></div>	</div>

	<div class="traces">
		<h2>Stack Trace</h2>
				<table style="width:100%;">
						<tbody><tr class="trace core expanded">
			<td class="number">
				#0			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/framework/db/CDbCommand.php(337): <strong>PDOStatement</strong>-&gt;<strong>execute</strong>(array(":anonymized" =&gt; "N", ":savetimings" =&gt; "N", ":template" =&gt; "fruity", ":datestamp" =&gt; "N", ...))				</div>

				<div class="code"><pre><span class="ln">332</span> 
<span class="ln">333</span>             $this-&gt;prepare();
<span class="ln">334</span>             if($params===array())
<span class="ln">335</span>                 $this-&gt;_statement-&gt;execute();
<span class="ln">336</span>             else
<span class="error"><span class="ln error-ln">337</span>                 $this-&gt;_statement-&gt;execute($params);
</span><span class="ln">338</span>             $n=$this-&gt;_statement-&gt;rowCount();
<span class="ln">339</span> 
<span class="ln">340</span>             if($this-&gt;_connection-&gt;enableProfiling)
<span class="ln">341</span>                 Yii::endProfile('system.db.CDbCommand.execute('.$this-&gt;getText().$par.')','system.db.CDbCommand.execute');
<span class="ln">342</span> 
</pre></div>			</td>
		</tr>
						<tr class="trace core expanded">
			<td class="number">
				#1			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/framework/db/CDbCommand.php(1278): <strong>CDbCommand</strong>-&gt;<strong>execute</strong>(array(":anonymized" =&gt; "N", ":savetimings" =&gt; "N", ":template" =&gt; "fruity", ":datestamp" =&gt; "N", ...))				</div>

				<div class="code"><pre><span class="ln">1273</span>             }
<span class="ln">1274</span>         }
<span class="ln">1275</span>         $sql='INSERT INTO ' . $this-&gt;_connection-&gt;quoteTableName($table)
<span class="ln">1276</span>             . ' (' . implode(', ',$names) . ') VALUES ('
<span class="ln">1277</span>             . implode(', ', $placeholders) . ')';
<span class="error"><span class="ln error-ln">1278</span>         return $this-&gt;setText($sql)-&gt;execute($params);
</span><span class="ln">1279</span>     }
<span class="ln">1280</span> 
<span class="ln">1281</span>     /**
<span class="ln">1282</span>      * Creates and executes an UPDATE SQL statement.
<span class="ln">1283</span>      * The method will properly escape the column names and bind the values to be updated.
</pre></div>			</td>
		</tr>
						<tr class="trace app expanded">
			<td class="number">
				#2			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/application/helpers/update/updatedb_helper.php(2980): <strong>CDbCommand</strong>-&gt;<strong>insert</strong>("{{surveys_groupsettings}}",
 array("anonymized" =&gt; "N", "savetimings" =&gt; "N", "template" =&gt;
 "fruity", "datestamp" =&gt; "N", ...))				</div>

				<div class="code"><pre><span class="ln">2975</span>     // set db values to model
<span class="ln">2976</span>     $settings1-&gt;showqnumcode = ($globalSetting1 == 'choose') ? 'none' : $globalSetting1;
<span class="ln">2977</span>     $settings1-&gt;showgroupinfo = ($globalSetting2 == 'choose') ? 'both' : $globalSetting2;
<span class="ln">2978</span>     $settings1-&gt;shownoanswer = ($globalSetting3 == '2') ? '1' : $globalSetting3;
<span class="ln">2979</span>     $settings1-&gt;showxquestions = ($globalSetting4 == 'choose') ? 'show' : $globalSetting4;
<span class="error"><span class="ln error-ln">2980</span>     $oDB-&gt;createCommand()-&gt;insert("{{surveys_groupsettings}}", $settings1-&gt;attributes);
</span><span class="ln">2981</span> 
<span class="ln">2982</span>     // insert settings for default survey group
<span class="ln">2983</span>     $settings2 = new SurveysGroupsettings;
<span class="ln">2984</span>     $settings2-&gt;setToInherit();
<span class="ln">2985</span>     $settings2-&gt;gsid = 1;
</pre></div>			</td>
		</tr>
						<tr class="trace app expanded">
			<td class="number">
				#3			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/application/helpers/update/updatedb_helper.php(2496): <strong>createSurveysGroupSettingsTable</strong>(DbConnection)				</div>

				<div class="code"><pre><span class="ln">2491</span>         /**
<span class="ln">2492</span>          * Add sureys_groupsettings table and update settings_global table 
<span class="ln">2493</span>          */
<span class="ln">2494</span>         if ($iOldDBVersion &lt; 404) {
<span class="ln">2495</span>             $oTransaction = $oDB-&gt;beginTransaction();
<span class="error"><span class="ln error-ln">2496</span>             createSurveysGroupSettingsTable($oDB);
</span><span class="ln">2497</span>             $oDB-&gt;createCommand()-&gt;update('{{settings_global}}',array('stg_value'=&gt;404),"stg_name='DBVersion'");
<span class="ln">2498</span>             $oTransaction-&gt;commit();
<span class="ln">2499</span>         }
<span class="ln">2500</span>       
<span class="ln">2501</span>     } catch (Exception $e) {
</pre></div>			</td>
		</tr>
						<tr class="trace app expanded">
			<td class="number">
				#4			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/application/controllers/AdminController.php(126): <strong>db_upgrade_all</strong>(403, true)				</div>

				<div class="code"><pre><span class="ln">121</span>             $sDBVersion = getGlobalSetting('DBVersion');
<span class="ln">122</span>         }
<span class="ln">123</span>         if ((int) $sDBVersion &lt; Yii::app()-&gt;getConfig('dbversionnumber') &amp;&amp; $action != 'databaseupdate') {
<span class="ln">124</span>             // Try a silent update first
<span class="ln">125</span>             Yii::app()-&gt;loadHelper('update/updatedb');
<span class="error"><span class="ln error-ln">126</span>             if (!db_upgrade_all(intval($sDBVersion), true)) {
</span><span class="ln">127</span>                 $this-&gt;redirect(array('/admin/databaseupdate/sa/db'));
<span class="ln">128</span>             }
<span class="ln">129</span>         }
<span class="ln">130</span> 
<span class="ln">131</span> 
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#5			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/framework/web/CWebApplication.php(282): <strong>AdminController</strong>-&gt;<strong>run</strong>("")				</div>

				<div class="code"><pre><span class="ln">277</span>         {
<span class="ln">278</span>             list($controller,$actionID)=$ca;
<span class="ln">279</span>             $oldController=$this-&gt;_controller;
<span class="ln">280</span>             $this-&gt;_controller=$controller;
<span class="ln">281</span>             $controller-&gt;init();
<span class="error"><span class="ln error-ln">282</span>             $controller-&gt;run($actionID);
</span><span class="ln">283</span>             $this-&gt;_controller=$oldController;
<span class="ln">284</span>         }
<span class="ln">285</span>         else
<span class="ln">286</span>             throw new CHttpException(404,Yii::t('yii','Unable to resolve the request "{route}".',
<span class="ln">287</span>                 array('{route}'=&gt;$route===''?$this-&gt;defaultController:$route)));
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#6			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/framework/web/CWebApplication.php(141): <strong>CWebApplication</strong>-&gt;<strong>runController</strong>("admin")				</div>

				<div class="code"><pre><span class="ln">136</span>             foreach(array_splice($this-&gt;catchAllRequest,1) as $name=&gt;$value)
<span class="ln">137</span>                 $_GET[$name]=$value;
<span class="ln">138</span>         }
<span class="ln">139</span>         else
<span class="ln">140</span>             $route=$this-&gt;getUrlManager()-&gt;parseUrl($this-&gt;getRequest());
<span class="error"><span class="ln error-ln">141</span>         $this-&gt;runController($route);
</span><span class="ln">142</span>     }
<span class="ln">143</span> 
<span class="ln">144</span>     /**
<span class="ln">145</span>      * Registers the core application components.
<span class="ln">146</span>      * This method overrides the parent implementation by registering additional core components.
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#7			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/framework/base/CApplication.php(185): <strong>CWebApplication</strong>-&gt;<strong>processRequest</strong>()				</div>

				<div class="code"><pre><span class="ln">180</span>     public function run()
<span class="ln">181</span>     {
<span class="ln">182</span>         if($this-&gt;hasEventHandler('onBeginRequest'))
<span class="ln">183</span>             $this-&gt;onBeginRequest(new CEvent($this));
<span class="ln">184</span>         register_shutdown_function(array($this,'end'),0,false);
<span class="error"><span class="ln error-ln">185</span>         $this-&gt;processRequest();
</span><span class="ln">186</span>         if($this-&gt;hasEventHandler('onEndRequest'))
<span class="ln">187</span>             $this-&gt;onEndRequest(new CEvent($this));
<span class="ln">188</span>     }
<span class="ln">189</span> 
<span class="ln">190</span>     /**
</pre></div>			</td>
		</tr>
						<tr class="trace app collapsed">
			<td class="number">
				#8			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/index.php(194): <strong>CApplication</strong>-&gt;<strong>run</strong>()				</div>

				<div class="code"><pre><span class="ln">189</span> require_once APPPATH . 'core/LSYii_Application' . EXT;
<span class="ln">190</span> 
<span class="ln">191</span> $config = require_once(APPPATH . 'config/internal' . EXT);
<span class="ln">192</span> 
<span class="ln">193</span> Yii::$enableIncludePath = false;
<span class="error"><span class="ln error-ln">194</span> Yii::createApplication('LSYii_Application', $config)-&gt;run();
</span><span class="ln">195</span> 
<span class="ln">196</span> /* End of file index.php */
<span class="ln">197</span> /* Location: ./index.php */
</pre></div>			</td>
		</tr>
				</tbody></table>
	</div>

	<div class="version">
		2019-01-01 16:02:41 nginx/1.14.1 <a href="http://www.yiiframework.com/">Yii Framework</a>/1.1.20	</div>
</div>

<script type="text/javascript">
/*<![CDATA[*/
var traceReg = new RegExp("(^|\\s)trace-file(\\s|$)");
var collapsedReg = new RegExp("(^|\\s)collapsed(\\s|$)");

var e = document.getElementsByTagName("div");
for(var j=0,len=e.length;j<len;j++){
	if(traceReg.test(e[j].className)){
		e[j].onclick = function(){
			var trace = this.parentNode.parentNode;
			if(collapsedReg.test(trace.className))
				trace.className = trace.className.replace("collapsed", "expanded");
			else
				trace.className = trace.className.replace("expanded", "collapsed");
		}
	}
}
/*]]>*/
</script>



</body></html>
PHP notice.html (16,815 bytes)   
DenisChenu

DenisChenu

2019-01-01 17:09

developer   ~50083

OK,

Last db update aren't tested
[showxquestions] => Array
(
[stg_value] => choose
)

[showgroupinfo] => Array
    (
        [stg_value] => choose
    )

[shownoanswer] => Array
    (
        [stg_value] => 1
    )

[showqnumcode] => Array
    (
        [stg_value] => choose
    )
DenisChenu

DenisChenu

2019-01-01 17:12

developer   ~50084

And DB is invalid : 'showxquestions' => "string(1) NULL DEFAULT 'Y'" and
$settings1->showxquestions = (empty($globalSetting4->stg_value) ||$globalSetting4->stg_value == 'choose') ? 'show' : $globalSetting4->stg_value;

DenisChenu

DenisChenu

2019-01-01 17:13

developer  

CDbException.html (17,846 bytes)   
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"><head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>CDbException</title>

<style type="text/css">
/*<![CDATA[*/
html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,font,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,ol,ul,li,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td{border:0;outline:0;font-size:100%;vertical-align:baseline;background:transparent;margin:0;padding:0;}
body{line-height:1;}
ol,ul{list-style:none;}
blockquote,q{quotes:none;}
blockquote:before,blockquote:after,q:before,q:after{content:none;}
:focus{outline:0;}
ins{text-decoration:none;}
del{text-decoration:line-through;}
table{border-collapse:collapse;border-spacing:0;}

body {
	font: normal 9pt "Verdana";
	color: #000;
	background: #fff;
}

h1 {
	font: normal 18pt "Verdana";
	color: #f00;
	margin-bottom: .5em;
}

h2 {
	font: normal 14pt "Verdana";
	color: #800000;
	margin-bottom: .5em;
}

h3 {
	font: bold 11pt "Verdana";
}

pre {
	font: normal 11pt Menlo, Consolas, "Lucida Console", Monospace;
}

pre span.error {
	display: block;
	background: #fce3e3;
}

pre span.ln {
	color: #999;
	padding-right: 0.5em;
	border-right: 1px solid #ccc;
}

pre span.error-ln {
	font-weight: bold;
}

.container {
	margin: 1em 4em;
}

.version {
	color: gray;
	font-size: 8pt;
	border-top: 1px solid #aaa;
	padding-top: 1em;
	margin-bottom: 1em;
}

.message {
	color: #000;
	padding: 1em;
	font-size: 11pt;
	background: #f3f3f3;
	-webkit-border-radius: 10px;
	-moz-border-radius: 10px;
	border-radius: 10px;
	margin-bottom: 1em;
	line-height: 160%;
}

.source {
	margin-bottom: 1em;
}

.code pre {
	background-color: #ffe;
	margin: 0.5em 0;
	padding: 0.5em;
	line-height: 125%;
	border: 1px solid #eee;
}

.source .file {
	margin-bottom: 1em;
	font-weight: bold;
}

.traces {
	margin: 2em 0;
}

.trace {
	margin: 0.5em 0;
	padding: 0.5em;
}

.trace.app {
	border: 1px dashed #c00;
}

.trace .number {
	text-align: right;
	width: 2em;
	padding: 0.5em;
}

.trace .content {
	padding: 0.5em;
}

.trace .plus,
.trace .minus {
	display:inline;
	vertical-align:middle;
	text-align:center;
	border:1px solid #000;
	color:#000;
	font-size:10px;
	line-height:10px;
	margin:0;
	padding:0 1px;
	width:10px;
	height:10px;
}

.trace.collapsed .minus,
.trace.expanded .plus,
.trace.collapsed pre {
	display: none;
}

.trace-file {
	cursor: pointer;
	padding: 0.2em;
}

.trace-file:hover {
	background: #f0ffff;
}
/*]]>*/
</style>
</head>

<body>
<div class="container">
	<h1>CDbException</h1>

	<p class="message">
		CDbCommand n'a pas pu exécuter la commande SQL: SQLSTATE[22001]: 
String data, right truncated: 1406 Data too long for column 
'showxquestions' at row 1. The SQL statement executed was: INSERT INTO 
`lime_surveys_groupsettings` (`anonymized`, `savetimings`, `template`, 
`datestamp`, `usecookie`, `allowregister`, `allowsave`, 
`autonumber_start`, `autoredirect`, `allowprev`, `printanswers`, 
`ipaddr`, `refurl`, `showsurveypolicynotice`, `publicstatistics`, 
`publicgraphs`, `listpublic`, `htmlemail`, `sendconfirmation`, 
`tokenanswerspersistence`, `assessments`, `usecaptcha`, `tokenlength`, 
`showxquestions`, `showgroupinfo`, `shownoanswer`, `showqnumcode`, 
`showwelcome`, `showprogress`, `questionindex`, `navigationdelay`, 
`nokeyboard`, `alloweditaftercompletion`, `owner_id`, `format`, `admin`,
 `adminemail`, `gsid`, `bounce_email`, `attributedescriptions`, 
`emailresponseto`, `emailnotificationto`) VALUES (:anonymized, 
:savetimings, :template, :datestamp, :usecookie, :allowregister, 
:allowsave, :autonumber_start, :autoredirect, :allowprev, :printanswers,
 :ipaddr, :refurl, :showsurveypolicynotice, :publicstatistics, 
:publicgraphs, :listpublic, :htmlemail, :sendconfirmation, 
:tokenanswerspersistence, :assessments, :usecaptcha, :tokenlength, 
:showxquestions, :showgroupinfo, :shownoanswer, :showqnumcode, 
:showwelcome, :showprogress, :questionindex, :navigationdelay, 
:nokeyboard, :alloweditaftercompletion, :owner_id, :format, :admin, 
:adminemail, :gsid, :bounce_email, :attributedescriptions, 
:emailresponseto, :emailnotificationto)	</p>

	<div class="source">
		<p class="file">/mnt/data/shnoulle/nginx/www/develop/framework/db/CDbCommand.php(358)</p>
		<div class="code"><pre><span class="ln">346</span>         {
<span class="ln">347</span>             if($this-&gt;_connection-&gt;enableProfiling)
<span class="ln">348</span>                 Yii::endProfile('system.db.CDbCommand.execute('.$this-&gt;getText().$par.')','system.db.CDbCommand.execute');
<span class="ln">349</span> 
<span class="ln">350</span>             $errorInfo=$e instanceof PDOException ? $e-&gt;errorInfo : null;
<span class="ln">351</span>             $message=$e-&gt;getMessage();
<span class="ln">352</span>             Yii::log(Yii::t('yii','CDbCommand::execute() failed: {error}. The SQL statement executed was: {sql}.',
<span class="ln">353</span>                 array('{error}'=&gt;$message, '{sql}'=&gt;$this-&gt;getText().$par)),CLogger::LEVEL_ERROR,'system.db.CDbCommand');
<span class="ln">354</span> 
<span class="ln">355</span>             if(YII_DEBUG)
<span class="ln">356</span>                 $message.='. The SQL statement executed was: '.$this-&gt;getText().$par;
<span class="ln">357</span> 
<span class="error"><span class="ln error-ln">358</span>             throw new CDbException(Yii::t('yii','CDbCommand failed to execute the SQL statement: {error}',
</span><span class="ln">359</span>                 array('{error}'=&gt;$message)),(int)$e-&gt;getCode(),$errorInfo);
<span class="ln">360</span>         }
<span class="ln">361</span>     }
<span class="ln">362</span> 
<span class="ln">363</span>     /**
<span class="ln">364</span>      * Executes the SQL statement and returns query result.
<span class="ln">365</span>      * This method is for executing an SQL query that returns result set.
<span class="ln">366</span>      * @param array $params input parameters (name=&gt;value) for the SQL execution. This is an alternative
<span class="ln">367</span>      * to {@link bindParam} and {@link bindValue}. If you have multiple input parameters, passing
<span class="ln">368</span>      * them in this way can improve the performance. Note that if you pass parameters in this way,
<span class="ln">369</span>      * you cannot bind parameters or values using {@link bindParam} or {@link bindValue}, and vice versa.
<span class="ln">370</span>      * Please also note that all values are treated as strings in this case, if you need them to be handled as
</pre></div>	</div>

	<div class="traces">
		<h2>Stack Trace</h2>
				<table style="width:100%;">
						<tbody><tr class="trace core collapsed">
			<td class="number">
				#0			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/framework/db/CDbCommand.php(1278): <strong>CDbCommand</strong>-&gt;<strong>execute</strong>(array(":anonymized" =&gt; "N", ":savetimings" =&gt; "N", ":template" =&gt; "fruity", ":datestamp" =&gt; "N", ...))				</div>

				<div class="code"><pre><span class="ln">1273</span>             }
<span class="ln">1274</span>         }
<span class="ln">1275</span>         $sql='INSERT INTO ' . $this-&gt;_connection-&gt;quoteTableName($table)
<span class="ln">1276</span>             . ' (' . implode(', ',$names) . ') VALUES ('
<span class="ln">1277</span>             . implode(', ', $placeholders) . ')';
<span class="error"><span class="ln error-ln">1278</span>         return $this-&gt;setText($sql)-&gt;execute($params);
</span><span class="ln">1279</span>     }
<span class="ln">1280</span> 
<span class="ln">1281</span>     /**
<span class="ln">1282</span>      * Creates and executes an UPDATE SQL statement.
<span class="ln">1283</span>      * The method will properly escape the column names and bind the values to be updated.
</pre></div>			</td>
		</tr>
						<tr class="trace app expanded">
			<td class="number">
				#1			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/application/helpers/update/updatedb_helper.php(2980): <strong>CDbCommand</strong>-&gt;<strong>insert</strong>("{{surveys_groupsettings}}",
 array("anonymized" =&gt; "N", "savetimings" =&gt; "N", "template" =&gt;
 "fruity", "datestamp" =&gt; "N", ...))				</div>

				<div class="code"><pre><span class="ln">2975</span>     // set db values to model
<span class="ln">2976</span>     $settings1-&gt;showqnumcode = (empty($globalSetting1-&gt;stg_value) || $globalSetting1-&gt;stg_value == 'choose') ? 'none' : $globalSetting1-&gt;stg_value;
<span class="ln">2977</span>     $settings1-&gt;showgroupinfo = (empty($globalSetting2-&gt;stg_value) ||$globalSetting2-&gt;stg_value == 'choose') ? 'both' : $globalSetting2-&gt;stg_value;
<span class="ln">2978</span>     $settings1-&gt;shownoanswer = (empty($globalSetting3-&gt;stg_value) ||$globalSetting3-&gt;stg_value == '2') ? '1' : $globalSetting3-&gt;stg_value;
<span class="ln">2979</span>     $settings1-&gt;showxquestions = (empty($globalSetting4-&gt;stg_value) ||$globalSetting4-&gt;stg_value == 'choose') ? 'show' : $globalSetting4-&gt;stg_value;
<span class="error"><span class="ln error-ln">2980</span>     $oDB-&gt;createCommand()-&gt;insert("{{surveys_groupsettings}}", $settings1-&gt;attributes);
</span><span class="ln">2981</span> 
<span class="ln">2982</span>     // insert settings for default survey group
<span class="ln">2983</span>     $settings2 = new SurveysGroupsettings;
<span class="ln">2984</span>     $settings2-&gt;setToInherit();
<span class="ln">2985</span>     $settings2-&gt;gsid = 1;
</pre></div>			</td>
		</tr>
						<tr class="trace app expanded">
			<td class="number">
				#2			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/application/helpers/update/updatedb_helper.php(2496): <strong>createSurveysGroupSettingsTable</strong>(DbConnection)				</div>

				<div class="code"><pre><span class="ln">2491</span>         /**
<span class="ln">2492</span>          * Add sureys_groupsettings table and update settings_global table 
<span class="ln">2493</span>          */
<span class="ln">2494</span>         if ($iOldDBVersion &lt; 404) {
<span class="ln">2495</span>             $oTransaction = $oDB-&gt;beginTransaction();
<span class="error"><span class="ln error-ln">2496</span>             createSurveysGroupSettingsTable($oDB);
</span><span class="ln">2497</span>             $oDB-&gt;createCommand()-&gt;update('{{settings_global}}',array('stg_value'=&gt;404),"stg_name='DBVersion'");
<span class="ln">2498</span>             $oTransaction-&gt;commit();
<span class="ln">2499</span>         }
<span class="ln">2500</span>       
<span class="ln">2501</span>     } catch (Exception $e) {
</pre></div>			</td>
		</tr>
						<tr class="trace app expanded">
			<td class="number">
				#3			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/application/controllers/AdminController.php(126): <strong>db_upgrade_all</strong>(403, true)				</div>

				<div class="code"><pre><span class="ln">121</span>             $sDBVersion = getGlobalSetting('DBVersion');
<span class="ln">122</span>         }
<span class="ln">123</span>         if ((int) $sDBVersion &lt; Yii::app()-&gt;getConfig('dbversionnumber') &amp;&amp; $action != 'databaseupdate') {
<span class="ln">124</span>             // Try a silent update first
<span class="ln">125</span>             Yii::app()-&gt;loadHelper('update/updatedb');
<span class="error"><span class="ln error-ln">126</span>             if (!db_upgrade_all(intval($sDBVersion), true)) {
</span><span class="ln">127</span>                 $this-&gt;redirect(array('/admin/databaseupdate/sa/db'));
<span class="ln">128</span>             }
<span class="ln">129</span>         }
<span class="ln">130</span> 
<span class="ln">131</span> 
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#4			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/framework/web/CWebApplication.php(282): <strong>AdminController</strong>-&gt;<strong>run</strong>("")				</div>

				<div class="code"><pre><span class="ln">277</span>         {
<span class="ln">278</span>             list($controller,$actionID)=$ca;
<span class="ln">279</span>             $oldController=$this-&gt;_controller;
<span class="ln">280</span>             $this-&gt;_controller=$controller;
<span class="ln">281</span>             $controller-&gt;init();
<span class="error"><span class="ln error-ln">282</span>             $controller-&gt;run($actionID);
</span><span class="ln">283</span>             $this-&gt;_controller=$oldController;
<span class="ln">284</span>         }
<span class="ln">285</span>         else
<span class="ln">286</span>             throw new CHttpException(404,Yii::t('yii','Unable to resolve the request "{route}".',
<span class="ln">287</span>                 array('{route}'=&gt;$route===''?$this-&gt;defaultController:$route)));
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#5			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/framework/web/CWebApplication.php(141): <strong>CWebApplication</strong>-&gt;<strong>runController</strong>("admin")				</div>

				<div class="code"><pre><span class="ln">136</span>             foreach(array_splice($this-&gt;catchAllRequest,1) as $name=&gt;$value)
<span class="ln">137</span>                 $_GET[$name]=$value;
<span class="ln">138</span>         }
<span class="ln">139</span>         else
<span class="ln">140</span>             $route=$this-&gt;getUrlManager()-&gt;parseUrl($this-&gt;getRequest());
<span class="error"><span class="ln error-ln">141</span>         $this-&gt;runController($route);
</span><span class="ln">142</span>     }
<span class="ln">143</span> 
<span class="ln">144</span>     /**
<span class="ln">145</span>      * Registers the core application components.
<span class="ln">146</span>      * This method overrides the parent implementation by registering additional core components.
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#6			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/framework/base/CApplication.php(185): <strong>CWebApplication</strong>-&gt;<strong>processRequest</strong>()				</div>

				<div class="code"><pre><span class="ln">180</span>     public function run()
<span class="ln">181</span>     {
<span class="ln">182</span>         if($this-&gt;hasEventHandler('onBeginRequest'))
<span class="ln">183</span>             $this-&gt;onBeginRequest(new CEvent($this));
<span class="ln">184</span>         register_shutdown_function(array($this,'end'),0,false);
<span class="error"><span class="ln error-ln">185</span>         $this-&gt;processRequest();
</span><span class="ln">186</span>         if($this-&gt;hasEventHandler('onEndRequest'))
<span class="ln">187</span>             $this-&gt;onEndRequest(new CEvent($this));
<span class="ln">188</span>     }
<span class="ln">189</span> 
<span class="ln">190</span>     /**
</pre></div>			</td>
		</tr>
						<tr class="trace app collapsed">
			<td class="number">
				#7			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/mnt/data/shnoulle/nginx/www/develop/index.php(194): <strong>CApplication</strong>-&gt;<strong>run</strong>()				</div>

				<div class="code"><pre><span class="ln">189</span> require_once APPPATH . 'core/LSYii_Application' . EXT;
<span class="ln">190</span> 
<span class="ln">191</span> $config = require_once(APPPATH . 'config/internal' . EXT);
<span class="ln">192</span> 
<span class="ln">193</span> Yii::$enableIncludePath = false;
<span class="error"><span class="ln error-ln">194</span> Yii::createApplication('LSYii_Application', $config)-&gt;run();
</span><span class="ln">195</span> 
<span class="ln">196</span> /* End of file index.php */
<span class="ln">197</span> /* Location: ./index.php */
</pre></div>			</td>
		</tr>
				</tbody></table>
	</div>

	<div class="version">
		2019-01-01 16:10:57 nginx/1.14.1 <a href="http://www.yiiframework.com/">Yii Framework</a>/1.1.20	</div>
</div>

<script type="text/javascript">
/*<![CDATA[*/
var traceReg = new RegExp("(^|\\s)trace-file(\\s|$)");
var collapsedReg = new RegExp("(^|\\s)collapsed(\\s|$)");

var e = document.getElementsByTagName("div");
for(var j=0,len=e.length;j<len;j++){
	if(traceReg.test(e[j].className)){
		e[j].onclick = function(){
			var trace = this.parentNode.parentNode;
			if(collapsedReg.test(trace.className))
				trace.className = trace.className.replace("collapsed", "expanded");
			else
				trace.className = trace.className.replace("expanded", "collapsed");
		}
	}
}
/*]]>*/
</script>



</body></html>
CDbException.html (17,846 bytes)   
DenisChenu

DenisChenu

2019-01-01 17:14

developer   ~50085

https://github.com/LimeSurvey/LimeSurvey/commit/97a8a549ecd916e62feebf5a92a9b65372541ae7#diff-fb32bdf0b19fecbe2d24aa8be88536e4

guest

guest

2019-01-02 13:49

viewer   ~50086

Fix committed to develop branch: http://bugs.limesurvey.org/plugin.php?page=Source/view&amp;id=28696

Related Changesets

LimeSurvey: develop f26b07c6

2019-01-02 13:48:42

Dominik Vitt

Details Diff
Fixed issue 14387: "Array to string conversion" message while upgrading to v4.0.0-alpha Affected Issues
14387
mod - application/helpers/update/updatedb_helper.php Diff File

Issue History

Date Modified Username Field Change
2019-01-01 17:08 DenisChenu New Issue
2019-01-01 17:08 DenisChenu File Added: PHP notice.html
2019-01-01 17:09 DenisChenu Note Added: 50083
2019-01-01 17:12 DenisChenu Note Added: 50084
2019-01-01 17:13 DenisChenu File Added: CDbException.html
2019-01-01 17:13 DenisChenu Assigned To => dominikvitt
2019-01-01 17:13 DenisChenu Status new => assigned
2019-01-01 17:14 DenisChenu Note Added: 50085
2019-01-02 13:49 Changeset attached => LimeSurvey develop f26b07c6
2019-01-02 13:49 guest Note Added: 50086
2019-01-02 13:49 guest Resolution open => fixed
2019-05-15 12:56 dominikvitt Status assigned => closed